package com.zhentao.system.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @TableName course
 */
@TableName(value ="course")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class Course implements Serializable {
    private Integer courseId;

    private String courseName;

    private String courseDescription;

    private Integer courseCategory;

    private Integer instructorId;

    private String courseCover;

    private BigDecimal coursePrice;

    private Integer courseDuration;

    private Date createTime;

    private Date updateTime;

    private Object courseStatus;

    private Integer studyNum;

    private Integer isFree;

    private Integer recommendIndex;

    private String courseOutline;

    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        com.zhentao.system.domain.Course other = (com.zhentao.system.domain.Course) that;
        return (this.getCourseId() == null ? other.getCourseId() == null : this.getCourseId().equals(other.getCourseId()))
                && (this.getCourseName() == null ? other.getCourseName() == null : this.getCourseName().equals(other.getCourseName()))
                && (this.getCourseDescription() == null ? other.getCourseDescription() == null : this.getCourseDescription().equals(other.getCourseDescription()))
                && (this.getCourseCategory() == null ? other.getCourseCategory() == null : this.getCourseCategory().equals(other.getCourseCategory()))
                && (this.getInstructorId() == null ? other.getInstructorId() == null : this.getInstructorId().equals(other.getInstructorId()))
                && (this.getCourseCover() == null ? other.getCourseCover() == null : this.getCourseCover().equals(other.getCourseCover()))
                && (this.getCoursePrice() == null ? other.getCoursePrice() == null : this.getCoursePrice().equals(other.getCoursePrice()))
                && (this.getCourseDuration() == null ? other.getCourseDuration() == null : this.getCourseDuration().equals(other.getCourseDuration()))
                && (this.getCreateTime() == null ? other.getCreateTime() == null : this.getCreateTime().equals(other.getCreateTime()))
                && (this.getUpdateTime() == null ? other.getUpdateTime() == null : this.getUpdateTime().equals(other.getUpdateTime()))
                && (this.getCourseStatus() == null ? other.getCourseStatus() == null : this.getCourseStatus().equals(other.getCourseStatus()))
                && (this.getStudyNum() == null ? other.getStudyNum() == null : this.getStudyNum().equals(other.getStudyNum()))
                && (this.getIsFree() == null ? other.getIsFree() == null : this.getIsFree().equals(other.getIsFree()))
                && (this.getRecommendIndex() == null ? other.getRecommendIndex() == null : this.getRecommendIndex().equals(other.getRecommendIndex()))
                && (this.getCourseOutline() == null ? other.getCourseOutline() == null : this.getCourseOutline().equals(other.getCourseOutline()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getCourseId() == null) ? 0 : getCourseId().hashCode());
        result = prime * result + ((getCourseName() == null) ? 0 : getCourseName().hashCode());
        result = prime * result + ((getCourseDescription() == null) ? 0 : getCourseDescription().hashCode());
        result = prime * result + ((getCourseCategory() == null) ? 0 : getCourseCategory().hashCode());
        result = prime * result + ((getInstructorId() == null) ? 0 : getInstructorId().hashCode());
        result = prime * result + ((getCourseCover() == null) ? 0 : getCourseCover().hashCode());
        result = prime * result + ((getCoursePrice() == null) ? 0 : getCoursePrice().hashCode());
        result = prime * result + ((getCourseDuration() == null) ? 0 : getCourseDuration().hashCode());
        result = prime * result + ((getCreateTime() == null) ? 0 : getCreateTime().hashCode());
        result = prime * result + ((getUpdateTime() == null) ? 0 : getUpdateTime().hashCode());
        result = prime * result + ((getCourseStatus() == null) ? 0 : getCourseStatus().hashCode());
        result = prime * result + ((getStudyNum() == null) ? 0 : getStudyNum().hashCode());
        result = prime * result + ((getIsFree() == null) ? 0 : getIsFree().hashCode());
        result = prime * result + ((getRecommendIndex() == null) ? 0 : getRecommendIndex().hashCode());
        result = prime * result + ((getCourseOutline() == null) ? 0 : getCourseOutline().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", courseId=").append(courseId);
        sb.append(", courseName=").append(courseName);
        sb.append(", courseDescription=").append(courseDescription);
        sb.append(", courseCategory=").append(courseCategory);
        sb.append(", instructorId=").append(instructorId);
        sb.append(", courseCover=").append(courseCover);
        sb.append(", coursePrice=").append(coursePrice);
        sb.append(", courseDuration=").append(courseDuration);
        sb.append(", createTime=").append(createTime);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", courseStatus=").append(courseStatus);
        sb.append(", studyNum=").append(studyNum);
        sb.append(", isFree=").append(isFree);
        sb.append(", recommendIndex=").append(recommendIndex);
        sb.append(", courseOutline=").append(courseOutline);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}
